Index: src/embeddedLua/CMakeLists.txt
===================================================================
--- src/embeddedLua/CMakeLists.txt	(revision 74719)
+++ src/embeddedLua/CMakeLists.txt	(working copy)
@@ -44,6 +44,7 @@
     initbrlcad.cpp
     luadatabase.cpp
     paraboliccylinder.cpp
+    particle.cpp
     sphere.cpp
     torus.cpp
     vector3d.cpp
Index: src/embeddedLua/initbrlcad.cpp
===================================================================
--- src/embeddedLua/initbrlcad.cpp	(revision 74719)
+++ src/embeddedLua/initbrlcad.cpp	(working copy)
@@ -35,6 +35,7 @@
 #include "luadatabase.h"
 #include "sphere.h"
 #include "paraboliccylinder.h"
+#include "particle.h"
 #include "torus.h"
 #include "initbrlcad.h"
 
@@ -49,6 +50,7 @@
     InitHyperbolicCylinder(luaState);
     InitHyperboloid(luaState);
     InitParabolicCylinder(luaState);
+    InitParticle(luaState);
     InitSphere(luaState);
     InitTorus(luaState);
 
Index: src/embeddedLua/particle.cpp
===================================================================
--- src/embeddedLua/particle.cpp	(nonexistent)
+++ src/embeddedLua/particle.cpp	(working copy)
@@ -0,0 +1,342 @@
+/*                         P A R T I C L E . C P P
+ * BRL-CAD
+ *
+ * Copyright (c) 2020 United States Government as represented by
+ * the U.S. Army Research Laboratory.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in all
+ * copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
+ * SOFTWARE.
+ */
+/** @file particle.cpp
+ *
+ *  BRL-CAD embedded lua script:
+ *      BRLCAD::Particle functions
+ */
+
+#include <cassert>
+
+#include "objectbase.h"
+#include "vector3d.h"
+#include "particle.h"
+
+
+struct ScriptParticle {
+    BRLCAD::Particle* object;
+    bool              own;
+};
+
+
+static BRLCAD::Particle& GetParticle
+(
+    lua_State* luaState,
+    int        narg
+) {
+    BRLCAD::Particle* object = TestParticle(luaState, narg);
+    assert(object != 0);
+
+    return *object;
+}
+
+
+static int CreateParticle
+(
+    lua_State* luaState
+) {
+    BRLCAD::Particle* ret = 0;
+
+    if (lua_gettop(luaState) > 0) {
+        BRLCAD::Particle* original = TestParticle(luaState, 1);
+
+        if (original != 0)
+            ret = new BRLCAD::Particle(*original);
+    }
+
+    if (ret == 0)
+        ret = new BRLCAD::Particle();
+
+    return PushParticle(luaState, ret, true);
+}
+
+
+static int Destruct
+(
+    lua_State* luaState
+) {
+    ScriptParticle* scriptObject = static_cast<ScriptParticle*>(luaL_testudata(luaState, 1, "BRLCAD.Particle"));
+
+    if ((scriptObject != 0) && (scriptObject->object != 0) && scriptObject->own)
+        scriptObject->object->Destroy();
+
+    return 0;
+}
+
+
+static int BasePoint
+(
+    lua_State* luaState
+) {
+    BRLCAD::Particle& object = GetParticle(luaState, 1);
+
+    PushVector3D(luaState, object.BasePoint());
+
+    return 1;
+}
+
+
+static int SetBasePoint
+(
+    lua_State* luaState
+) {
+    BRLCAD::Particle& object    = GetParticle(luaState, 1);
+    BRLCAD::Vector3D  basePoint = GetVector3D(luaState, 2);
+
+    object.SetBasePoint(basePoint);
+
+    return 0;
+}
+
+
+static int Height
+(
+    lua_State* luaState
+) {
+    BRLCAD::Particle& object = GetParticle(luaState, 1);
+
+    PushVector3D(luaState, object.Height());
+
+    return 1;
+}
+
+
+static int SetHeight
+(
+    lua_State* luaState
+) {
+    BRLCAD::Particle& object = GetParticle(luaState, 1);
+    BRLCAD::Vector3D  height = GetVector3D(luaState, 2);
+
+    object.SetHeight(height);
+
+    return 0;
+}
+
+
+static int BaseRadius
+(
+    lua_State* luaState
+) {
+    BRLCAD::Particle& object = GetParticle(luaState, 1);
+
+    lua_pushnumber(luaState, object.BaseRadius());
+
+    return 1;
+}
+
+
+static int SetBaseRadius
+(
+    lua_State* luaState
+) {
+    BRLCAD::Particle& object     = GetParticle(luaState, 1);
+    double            baseRadius = luaL_checknumber(luaState, 2);
+
+    object.SetBaseRadius(baseRadius);
+
+    return 0;
+}
+
+
+static int TopRadius
+(
+    lua_State* luaState
+) {
+    BRLCAD::Particle& object = GetParticle(luaState, 1);
+
+    lua_pushnumber(luaState, object.TopRadius());
+
+    return 1;
+}
+
+
+static int SetTopRadius
+(
+    lua_State* luaState
+) {
+    BRLCAD::Particle& object    = GetParticle(luaState, 1);
+    double            topRadius = luaL_checknumber(luaState, 2);
+
+    object.SetTopRadius(topRadius);
+
+    return 0;
+}
+
+
+static int Set
+(
+    lua_State* luaState
+) {
+    BRLCAD::Particle& object     = GetParticle(luaState, 1);
+    BRLCAD::Vector3D  basePoint  = GetVector3D(luaState, 2);
+    BRLCAD::Vector3D  height     = GetVector3D(luaState, 3);
+    double            baseRadius = luaL_checknumber(luaState, 4);
+    double            topRadius  = luaL_checknumber(luaState, 5);
+
+    object.Set(basePoint, height, baseRadius, topRadius);
+
+    return 0;
+}
+
+
+static int ClassName
+(
+    lua_State* luaState
+) {
+    lua_pushstring(luaState, BRLCAD::Particle::ClassName());
+
+    return 1;
+}
+
+
+static BRLCAD::Object& GetObject
+(
+    lua_State* luaState,
+    int        narg
+) {
+    return GetParticle(luaState, narg);
+}
+
+
+static void GetParticleMetatable
+(
+     lua_State* luaState
+) {
+    lua_getfield(luaState, LUA_REGISTRYINDEX, "BRLCAD.Particle");
+
+    if (!lua_istable(luaState, -1)) {
+        lua_pop(luaState, 1);
+        luaL_newmetatable(luaState, "BRLCAD.Particle");
+
+        lua_pushvalue(luaState, -1);
+        lua_setfield(luaState, -2, "__index");
+
+        lua_pushstring(luaState, "__gc");
+        lua_pushcfunction(luaState, &Destruct);
+        lua_settable(luaState, -3);
+
+        PushObjectMetatable<GetObject>(luaState);
+
+        lua_pushstring(luaState, "BasePoint");
+        lua_pushcfunction(luaState, &BasePoint);
+        lua_settable(luaState, -3);
+
+        lua_pushstring(luaState, "SetBasePoint");
+        lua_pushcfunction(luaState, &SetBasePoint);
+        lua_settable(luaState, -3);
+
+        lua_pushstring(luaState, "Height");
+        lua_pushcfunction(luaState, &Height);
+        lua_settable(luaState, -3);
+
+        lua_pushstring(luaState, "SetHeight");
+        lua_pushcfunction(luaState, &SetHeight);
+        lua_settable(luaState, -3);
+
+        lua_pushstring(luaState, "BaseRadius");
+        lua_pushcfunction(luaState, &SetBaseRadius);
+        lua_settable(luaState, -3);
+
+        lua_pushstring(luaState, "TopRadius");
+        lua_pushcfunction(luaState, &TopRadius);
+        lua_settable(luaState, -3);
+
+        lua_pushstring(luaState, "SetTopRadius");
+        lua_pushcfunction(luaState, &SetTopRadius);
+        lua_settable(luaState, -3);
+
+        lua_pushstring(luaState, "Set");
+        lua_pushcfunction(luaState, &Set);
+        lua_settable(luaState, -3);
+
+        lua_pushstring(luaState, "Clone");
+        lua_pushcfunction(luaState, &CreateParticle);
+        lua_settable(luaState, -3);
+
+        lua_pushstring(luaState, "ClassName");
+        lua_pushcfunction(luaState, &ClassName);
+        lua_settable(luaState, -3);
+    }
+}
+
+
+void InitParticle
+(
+    lua_State* luaState
+) {
+    lua_getglobal(luaState, "BRLCAD");
+
+    if (!lua_istable(luaState, -1)) {
+        lua_pop(luaState, 1);
+        lua_newtable(luaState);
+        lua_setglobal(luaState, "BRLCAD");
+        lua_getglobal(luaState, "BRLCAD");
+    }
+
+    lua_pushcfunction(luaState, &CreateParticle);
+    lua_setfield(luaState, -2, "Particle");
+
+    lua_pop(luaState, 1);
+}
+
+
+int PushParticle
+(
+    lua_State*        luaState,
+    BRLCAD::Particle* object,
+    bool              takeOwnership
+) {
+    int ret = 0;
+
+    if (object != 0) {
+        ScriptParticle* scriptObject = static_cast<ScriptParticle*>(lua_newuserdata(luaState, sizeof(ScriptParticle)));
+
+        scriptObject->object = object;
+        scriptObject->own    = takeOwnership;
+
+        GetParticleMetatable(luaState);
+        lua_setmetatable(luaState, -2);
+
+        ret = 1;
+    }
+
+    return ret;
+}
+
+
+BRLCAD::Particle* TestParticle
+(
+    lua_State* luaState,
+    int        narg
+) {
+    BRLCAD::Particle* ret          = 0;
+    ScriptParticle*   scriptObject = static_cast<ScriptParticle*>(luaL_testudata(luaState, narg, "BRLCAD.Particle"));
+
+    if (scriptObject != 0)
+        ret = scriptObject->object;
+
+    return ret;
+}
Index: src/embeddedLua/particle.h
===================================================================
--- src/embeddedLua/particle.h	(nonexistent)
+++ src/embeddedLua/particle.h	(working copy)
@@ -0,0 +1,60 @@
+/*                         P A R T I C L E . H
+ * BRL-CAD
+ *
+ * Copyright (c) 2020 United States Government as represented by
+ * the U.S. Army Research Laboratory.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in all
+ * copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
+ * SOFTWARE.
+ */
+/** @file particle.h
+ *
+ *  BRL-CAD embedded lua script:
+ *      BRLCAD::Particle functions
+ */
+
+#ifndef PARTICLE_INCLUDED
+#define PARTICLE_INCLUDED
+
+#include "lua.hpp"
+
+#include "brlcad/Particle.h"
+
+
+void InitParticle
+(
+    lua_State* luaState
+);
+
+
+int PushParticle
+(
+    lua_State*        luaState,
+    BRLCAD::Particle* object,
+    bool              takeOwnership
+);
+
+
+BRLCAD::Particle* TestParticle
+(
+    lua_State* luaState,
+    int        narg
+);
+
+
+#endif // PARTICLE_INCLUDED
